<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Массивы</title>
</head>
<body>
	
<script type=text/javascript>	

var studentsAndPoints = ['Алексей Петров',0, 'Ирина Овчинникова',60,'Глеб Стукалов',30,'Антон Павлович',30,'Виктория Заровская',30,'Алексей Левенец',70,'Тимур Вамуш',30,'Евгений Прочан',60,'Александр Малов',0];

document.write('Список студентов :' +'<br />');
for (var i = 0; i < studentsAndPoints.length; i+=2) {
	var ball = studentsAndPoints[i+1]
	document.write('Студент ' + studentsAndPoints[i] + ' набрал ' + ball + ' баллов ' + '<br />');
}

 document.write('<br /><br />');


/*Максимальный балл*/
document.write('Студент набравший максимальный балл:' + '<br />');

var maxBall = studentsAndPoints[1];
for(var i = 1; i < studentsAndPoints.length; i+=2){
	if(maxBall < studentsAndPoints[i]){
		maxBall = studentsAndPoints[i];
	var bestStudent = studentsAndPoints[i-1];
	}
	
}
document.write('Студент '+ bestStudent+ ' имеет максимальный балл: '+maxBall+'<br /><br />');



document.write('Доработка по ДЗ: '+ '<br />');


/*Максимальный балл по новому списку со студентами*/
var studentsAndPoints2 = ['Алексей Петров',0, 'Николай Фролов',500,'Глеб Стукалов',30,'Антон Павлович',30,'Виктория Заровская',30,'Алексей Левенец',70,'Тимур Вамуш',30,'Евгений Прочан',60,'Александр Малов',0];

var maxBall2 = studentsAndPoints2[1];
for(var i = 1; i < studentsAndPoints2.length; i+=2){
	if(maxBall2 < studentsAndPoints2[i]){
		maxBall2 = studentsAndPoints2[i];
	var bestStudent2 = studentsAndPoints2[i-1];
	}
	
}
document.write('Студент '+ bestStudent2+ ' имеет максимальный балл: '+maxBall2+'<br />');
document.write('<br /><br />');
/*Добавление баллов ко второму массиву со студентами*/  
for(i=0; i < studentsAndPoints2.length; i+=2){
	if (studentsAndPoints2[i] = 'Николай Фролов'){
	studentsAndPoints2.splice(3,1,200);
	}	
}
 document.write(studentsAndPoints2);

 

 
  
 
/*Новые студенты*/
document.write('<br /><br />');
studentsAndPoints.push('Николай Фролов',0,'Олег Боровой',0);
document.write(studentsAndPoints);
/*Splice для студентов*/
document.write('<br /><br />');
studentsAndPoints.splice(7,1,40);
studentsAndPoints.splice(19,1,10);
document.write(studentsAndPoints);

/*Студенты не набравшие баллов*/

document.write('<br /><br />');
document.write('Студенты не набравшие баллов:' + '<br />');

var minBall = 0;
for (var i = 0; i < studentsAndPoints.length; i++) {
	if (studentsAndPoints[i] <= minBall) {
	var	lowStudent = studentsAndPoints[i-1];
		document.write (lowStudent + '<br />');
	}
}
	 

/*Дополнительное задание*/
document.write('<br />Дополнительное задание: Удалить из массива данные о студентах, набравших 0 баллов :<br />');

for (var i = 0; i < studentsAndPoints.length; i++) {
	if (studentsAndPoints[i] === 0) {
  studentsAndPoints.splice(i-1,2);
  i--; 
	}
}
document.write(studentsAndPoints+"<br /><br />");
 

/*Доработка: Напишите такой код, который будет менять баллы в обоих списках.
 И при этом не потребует изменений в коде. Вы ведь его меняете сейчас.*/
/*Студенты «Антон Павлович» и «Николай Фролов» набрали еще по 10 баллов, внести изменения в массив. */

var studentsAndPoints2 = ['Алексей Петров',0, 'Николай Фролов',500,'Глеб Стукалов',30,'Антон Павлович',30,'Виктория Заровская',30,'Алексей Левенец',70,'Тимур Вамуш',30,'Евгений Прочан',60,'Александр Малов',0];
document.write("<b>Доработка по д/з: </b>");

function addPoints(studentName, newPoints){
	for(var i = 0; i < studentsAndPoints2.length; i+=2){
		if(studentName == studentsAndPoints2[i]){
			var totalPoints = studentsAndPoints2[i+1] + newPoints; 
			studentsAndPoints2.splice(i+1,1,totalPoints);
	document.write("<br />Студент "+studentName+ " набрал дополнительно" + newPoints + " баллов. Сейчас у студента всего "+totalPoints+ " баллов");
		}
	}
}
addPoints("Николай Фролов", 10); 
addPoints("Антон Павлович", 10); 

/*Ответ проверяющего:
Теперь перепишите эту функцию, чтобы она не использовала цикл*/

document.write("<br /><br /><b>Доработка по д/з:<br />Теперь перепишите эту функцию, чтобы она не использовала цикл</b><br />");

function addPoints2(studentName, newPoints){
	studentsAndPoints2.forEach(function(name, i){
		if(studentName == name){
		var totalPoints = studentsAndPoints2[i+1] + newPoints; 
			studentsAndPoints2.splice(i+1,1,totalPoints);
	document.write("<br />Студент "+studentName+ " набрал дополнительно" + newPoints + " баллов. Сейчас у студента всего "+totalPoints+ " баллов");
	console.log("<br />Студент "+studentName+ " набрал дополнительно" + newPoints + " баллов. Сейчас у студента всего "+totalPoints+ " баллов");
		}
	});
}

addPoints2("Алексей Петров", 10); 
addPoints2("Николай Фролов", 10); 

/*Ответ проверяющего:
Вы не поняли что я просил вас сделать. Уточню: без цикла и forEach.*/
document.write("<br /><br /><b>Доработка по д/з:<br />Ответ проверяющего: <br />Вы не поняли что я просил вас сделать. Уточню: без цикла и forEach.</b><br />");

function addPoints3(studentName,newPoints){
	studentsAndPoints2.map(function(point, i) {
		if (studentsAndPoints2[i] == studentName) {
			var totalPoints = studentsAndPoints2[i+1] + newPoints; 	
			studentsAndPoints2.splice(i+1,1,totalPoints);
			document.write("<br />Студент "+studentName+ " набрал дополнительно" + newPoints + " баллов. Сейчас у студента всего "+totalPoints+ " баллов");
			console.log("<br />Студент "+studentName+ " набрал дополнительно" + newPoints + " баллов. Сейчас у студента всего "+totalPoints+ " баллов");
			return point + newPoints;
		}else {
			return point;
		}
	});
}
 
addPoints3("Алексей Петров", 10); 
addPoints3("Николай Фролов", 10); 

/*Ответ преподавателя:
Продолжаем усложнять задачу: без map, find, filter и без reduce.*/
document.write("<br /><br /><b>Доработка по д/з:<br />Ответ проверяющего: <br />Продолжаем усложнять задачу: без map, find, filter и без reduce.</b><br />");

function addPoints4(studentName,newPoints){

	studentsAndPoints2.every(function(point, i) {
		if (studentsAndPoints2[i] == studentName) {
			var totalPoints = studentsAndPoints2[i+1] + newPoints; 	
			studentsAndPoints2.splice(i+1,1,totalPoints);
			document.write("<br />Студент "+studentName+ " набрал дополнительно" + newPoints + " баллов. Сейчас у студента всего "+totalPoints+ " баллов");
			console.log("<br />Студент "+studentName+ " набрал дополнительно" + newPoints + " баллов. Сейчас у студента всего "+totalPoints+ " баллов");
			return point + newPoints;
		}else {
			return point;
		}
	});
}

addPoints4("Алексей Петров", 100); 
addPoints4("Николай Фролов", 100); 


</script>



</body>
</body>
</html>